package client;

import java.net.ConnectException;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

import server.DataMessagePool;

public class MessageGetClient {
	
	public static void main(String[] args) {
		if (args.length <= 1 || !args[0].startsWith("rmi:")) {
			System.err.println("Usage: java MessageGetClient rmi://host.domain/persistMessagePool QueueName");
			return;
		}

		DataMessagePool pool;

		int interval = 2000; // 2000 milisecond retrieving interval
		int wait_time = interval; // the time to wait between two message retrievals

		String remoteObjectName = args[0];
		String queueName = args[1];

		while (true) {
			try {
				pool = (DataMessagePool) Naming.lookup(remoteObjectName);
				Thread.sleep(wait_time);

								
				// TO BE IMPLEMENTED
				// send RequestMessage for get operation
				// get AckMessage and fetch the ResultMessage
				// handle the OperationException attached in the ResultMessage
				
				
				wait_time = interval;//reset the wait_time to interval 
			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (MalformedURLException e) {
				e.printStackTrace();
			} catch (RemoteException e) {
				//	get the nested exception object in the RemoteException
				// determine its type and handle it correspondly
				Throwable nestedEx =  e.detail;
				if (nestedEx instanceof ConnectException) {
					wait_time += interval;
					System.err.println(nestedEx.getMessage() + ":: wait for " + wait_time / 1000 + " second for the next try");
				}
				else {
					System.err.println(nestedEx.toString());
				}
			} catch (NotBoundException e) {
				System.err.println("Cannot find the requested remote object on the server");
			}
		}
	}
}
