package client;

import java.net.ConnectException;
import java.net.MalformedURLException;
import java.rmi.Naming;
import java.rmi.NotBoundException;
import java.rmi.RemoteException;

import server.DataMessagePool;

public class MessagePutClient {

	public static void main(String[] args) {
		if (args.length <= 1 || !args[0].startsWith("rmi:")) {
			System.err.println("Usage: java MessagePutClient rmi://host.domain/persistMessagePool QueueName");
			return;
		}

		DataMessagePool pool;

		int interval = 1000; // 1000 milisecond sending interval
		int wait_time = interval; // the time to wait between two message
		// send

		String remoteObjectName = args[0];
		String queueName = args[1];

		while (true) {
			try {
				pool = (DataMessagePool) Naming.lookup(remoteObjectName);
				//pool.createQueue(queueName);

				Thread.sleep(wait_time);
				String msg = String.valueOf(System.currentTimeMillis());

				// TO BE IMPLEMENTED
				// send RequestMessage for get operation
				// get AckMessage and fetch the ResultMessage
				// handle the OperationException attached in the ResultMessage
				
				wait_time = interval;

			} catch (InterruptedException e) {
				e.printStackTrace();
			} catch (RemoteException e) {
				// get the nested exception object in the RemoteException
				// determine its type and handle it correspondly
				//System.err.println(e.toString());
				Throwable nestedEx = e.detail;
				
				if (nestedEx instanceof ConnectException) {
					wait_time += interval;
					System.err.println(nestedEx.getMessage() + ":: wait for " + wait_time / 1000 + " second for the next try");
				}
				else {
					System.err.println(nestedEx.toString());
				}

			} catch (MalformedURLException e) {
				System.err.println(args[0] + " is not a valid RMI URL");
			} catch (NotBoundException e) {
				System.err.println("Cannot find the requested remote object on the server");
			}
		}
	}
}
