package server.messaging;

import java.io.Serializable;

/**
 * AckMessage contains information of a Queue name and a message number
 * Upon receiving AckMessage, client retrieves the ResultMessage which is 
 * specified by the message number and the storing queue.
 */
public class AckMessage implements Serializable{
	private int msgNumber;
	private String queueName;
	
	public AckMessage(int msgNr, String qName) {
		msgNumber = msgNr;
		queueName = qName;
	}
	
	public String getQueueName() {
		return queueName;
	}
	
	public int getMessageNumber() {
		return msgNumber;
	}
}
